#!/usr/bin/perl
##############################################################################
# Cliff's Voting Booth Version 1.0                                           #
# Copyright 1998 Shaven Ferret Productions                                   #
# Created 6/26/98                                                            #
# Available at http://www.shavenferret.com/scripts                           #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1998 Shaven Ferret Productions All Rights Reserved.              #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header thing.  By using this script you agree to indemnify     #
# me from any liability that might arise from its use.  In simple English,   #
# if this script somehow makes your computer run amuck and kill the pope,    #
# it's not my fault.                                                         #
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################

# Set the next variable to the path of the directory where you will keep the
# data files.  This directory must be chmoded to 777.  Do not include a 
# trailing slash.
$data_path = "/server/path/to/votedata";

# if you don't want to allow your users to add their own topics, delete the
# next line.
$add_topic = 1;

# When creating a new topic, how many choices should I ask for?  Note that
# all of these choices do not need to be filled out.
$ask_choice = 13;

# Enter the title of your voting booth
$title = "My Voting Booth";

# What password do you want to use?  This password will be required for
# deleting voting booths, options, and if you aren't allowing your users
# to add topics, adding topics.
$password = "shavenferret.com";

##############################################################################
# Congratulations!  You've finished defining the variables.  If you want to, #
# you can continue screwing with the script, but it isn't necessary.         #
##############################################################################

# Put the posted data into variables

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $FORM{$name} = $value;
}

# Get the topics

open(DATA, "$data_path/vote.txt");
@data = <DATA>;
close(DATA);

# Decide what to do based on the $FORM{'action'} variable

print "Content-type: text/html\n\n";
if ($FORM{'action'} eq "admin") { &admin; }
elsif ($FORM{'action'} eq "add_topic") { &add_topic; }
elsif ($FORM{'action'} eq "showvote") { &showvote; }
elsif ($FORM{'action'} eq "others") { &others; }
elsif ($FORM{'action'} eq "vote") { &vote; }
elsif ($FORM{'action'} eq "results") { &results; }
elsif ($FORM{'action'} eq "delete") { &delete; }
else {
        print "<html><head><title>$title</title><body>\n";
        &sig;
        print "<h1>$title</h1>Welcome to my voting area!\n";
        if ($#data > 0) { print "Please vote on one of the following topics"; }
        elsif ($#data == 0) { print "Please vote on the following topic"; }
        else { print "Unfortunately, there are no topics that you can vote on right now.\n"; }
        if ($add_topic) {
                if (@data) { print ", or "; }
                else { print "Why not "; }
                print "<a href=\"#add_topic\">add your own topic</a>";
                if (@data) { print ".\n<center><table width=\"500\" border=\"5\"><tr><td><table cols=\"3\">"; }
                else { print "?\n"; }
        }
        else { if (@data) { print ":<center><table width=\"500\" border=\"5\"><tr><td><table cols=\"3\">\n"; } }                       
        foreach $line(@data) {
                ($topic, $num, $others) = split(/\|/, $line);                
                print "<tr><td align=\"right\" width=\"400\"><b>$topic</b></td>";
                $i = 0;
                open (FILE, "$data_path/ip$num.txt");
                @ips = <FILE>;
                close(FILE);
                foreach $ip(@ips) {
                        chomp($ip);
                        if ($ip eq $ENV{'REMOTE_ADDR'}) { $i = 1; }
                }
                if ($i == 0) {
                        print "<form method=\"POST\">\n";
                        print "<input type=\"hidden\" name=\"action\" value=\"showvote\">\n";
                        print "<input type=\"hidden\" name=\"topic\" value=\"$num\"><td width=\"50\">\n";
                        print "<input type=\"submit\" value=\" Vote! \"></td></form>\n";
                }
                else { print "<td width=\"50\">Already Voted</td>\n"; }
                print "<form method=\"POST\">\n";
                print "<input type=\"hidden\" name=\"action\" value=\"results\">\n";
                print "<input type=\"hidden\" name=\"topic\" value=\"$num\">\n";
                print "<td width=\"50\"><input type=\"submit\" value=\" Results \"></td></form>\n";
                print "</tr>\n";
        }
        if (@data) { print "</table></td></tr></table></center>\n"; }
        if ($add_topic) { &addtopic; }
        &sig;
        print "<center>Administration<form method=\"POST\"></center>\n";
        print "<table cols=\"2\"><tr><td align=\"right\">Password:</td>\n";
        print "<td><input type=\"password\" name=\"password\"></td></tr></table>\n";               
        print "<input type=\"hidden\" name=\"action\" value=\"admin\"><center>\n";
        print "<input type=\"submit\" value=\"Go to Admin\"></form></center></body></html>\n";
        exit;
}

sub checkpassword {
        if ($FORM{'password'} eq "") {
                print "<html><head><title>Password Required</title>\n";
                print "</head><body><h1>Password Required</h1>I'm sorry,\n";
                print "but you need a password to do that.\n";
                exit;
        }
        elsif ($FORM{'password'} ne $password) {
                print "<html><head><title>Bad Password</title></head><body>\n";
                print "<h1>Bad Password</h1>I'm sorry, but the password you entered,\n";
                print "<i>$FORM{'password'}</i>, is incorrect.";
                exit;
        }
}

sub sig {
        # Please DON'T change this sub, or any place where it is called.
        print "<center><hr width=\"70%\">Voting Booth script by Cliff(tm), <a ";
        print "href=\"http://www.shavenferret.com\" target=\"new\">Shaven ";
        print "Ferret Productions</a>, and can be found at <a href=\"http:";
        print "//www.shavenferret.com/scripts\" target=\"new\">http://www.";
        print "shavenferret.com/scripts</a>.<hr width=\"70%\"></center>\n";
}

sub addtopic {
        print "<center><hr width=\"300\"></center>\n";
        print "<a name=\"add_topic\"><h2>Add a topic:</h2></a>\n";
        print "<center><table width=\"500\" border=\"5\"><tr><td>\n";
        print "<form method=\"POST\"><input type=\"hidden\" name=\"action\"";
        print " value=\"add_topic\"><table cols=\"2\"><tr>\n";
        print "<td align=\"right\">What question do you want\n";
        print "people to vote on?</td><td><input type=\"text\"";        
        print " name=\"topic\"></td></tr>\n";
        for ($i = 0; $i < $ask_choice; $i++) {
                print "<tr><td align=\"right\">Enter a possible\n";
                print "choice, or leave this field blank:</td><td>\n";
                print "<input type=\"text\" name=\"$i\"></td></tr>\n";
        }
        print "<tr><td align=\"right\">Allow other's to add choices?</td><td>\n";
        print "<input type=\"radio\" name=\"others\" value=\"yes\" CHECKED>Yes\n";
        print "<input type=\"radio\" name=\"others\" value=\"no\">No</td></tr>\n";
        print "<tr><td align=\"right\"><input type=\"submit\"></td>\n";
        print "<td><input type=\"reset\"></td></tr><input type=\"hidden\"";
        print " name=\"password\" value=\"$FORM{'password'}\"></form>\n";
        print "</table></td></tr></table></center>\n";
}

sub add_topic {
        unless ($add_topic) { &checkpassword; }

        # Make sure a topic was given

        unless ($FORM{'topic'}) {
                print "<html><head><title>Nice topic, genius boy.</title></head>\n";
                print "<body><h1>Question Missing</h1>Please click back and try\n";
                print "again.</body></html>\n";
                exit;
        }

        # Make sure that at least one choice was given unless users are
        # allowed to add choices

        if ($FORM{'others'} eq "no") {
                $j = 0;
                for ($i = 0; $i < $ask_choice; $i++) { if ($FORM{$i}) { $j++; } }
                if ($j == 0) {
                        print "<html><head><title>Please add at least one choice</title>\n";
                        print "</head><body><h1>Please add a choice</h1>You need to either\n";
                        print "add a choice or allow others to add choices.  Please click\n";
                        print "back and try again.\n";
                        exit;
                }
        }

        # Add the topic to the main data

        ($i, $lastnum, $j) = split(/\|/, $data[$#data]);
        $lastnum++;
        open (FILE,">>$data_path/vote.txt");
        print FILE "$FORM{'topic'}|$lastnum|$FORM{'others'}\n";
        close(FILE);
        $FORM{'topic'} = $lastnum;
        open (FILE,">$data_path/ch$lastnum.txt");
        $num = 0;
        for ($i = 0; $i < $ask_choice; $i++) {
                if ($FORM{$i}) {
                        print FILE "$FORM{$i}|0|$num\n";
                        $num++;
                }
        }
        close(FILE);
        print "<html><head><title>Topic Added</title>\n";
        print "</head><body><h1>Topic Added</h1>Please click back and hit reload.\n";
}

sub admin {
        &checkpassword;
        print "<html><head><title>Administration</title></head><body>\n";
        print "<h1>Administration</h1>\n";

        # If there are any topics, print them out for deletion and allow you
        # to add and remove user's ability to add choices.

        if (@data) {
                print "<h2>Delete Topic or Choice</h2><ul>\n<form method=\"POST\">";
                print "\n<input type=\"hidden\" name=\"action\" value=\"delete\">\n";                        
                foreach $line(@data) {
                        ($topic, $numt, $others) = split(/\|/,$line);
                        print "<input type=\"radio\" name=\"which\" value=\"t|$numt|x\">\n";
                        print "<b>$topic</b><ul>\n";
                        open (FILE, "$data_path/ch$numt.txt");
                        @choices = <FILE>;
                        close(FILE);
                        foreach $choice(@choices) {
                                ($name,$votes,$numc) = split(/\|/, $choice);
                                print "<li><input type=\"radio\" name=\"which\" value=\"c|$numc|$numt\">";
                                print "<i>$name ($votes votes)</i>\n";
                        }
                        print "</ul>\n";
                }
                print "</ul><input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
                print "<input type=\"submit\" value=\" Delete \"></form>\n";
                print "<h2>Allow/Disallow adding choices</h2><center><form method=\"POST\">\n";
                print "<input type=\"hidden\" name=\"action\" value=\"others\">\n";
                print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
                print "<table border=\"5\" width=\"500\"><tr><td><table cols=\"2\">\n";
                foreach $line(@data) {
                        chomp($line);
                        ($topic, $num, $others) = split(/\|/,$line);
                        print "<tr><td align=\"right\" width=\"400\">$topic</td>";
                        print "<td width=\"100\"><input type=\"radio\" name=\"$num\"";
                        print " value=\"yes\"";
                        if ($others eq "yes") { print " checked"; }
                        print ">Allow<input type=\"radio\" name=\"$num\" value=\"no\" ";
                        if ($others eq "no") { print " checked"; }
                        print ">Disallow</td></tr>\n";
                }
                print "</table><center><input type=\"submit\"><input type=\"reset\"></form></td></tr></table>\n";
        }
        else { print "No topics to screw with.<p>\n"; }        
        &addtopic;
        print "</body></html>\n";
        exit;
}

sub others {
        &checkpassword;
        open (FILE, ">$data_path/vote.txt");
        foreach $line(@data) {
                ($topic, $num, $others) = split(/\|/,$line);
                print FILE "$topic|$num|$FORM{$num}\n";
        }
        close(FILE);
        &admin;
}

sub showvote {

        # Get the information for the topic

        foreach $line(@data) {
                ($topic,$num,$others) = split(/\|/, $line);
                if ($num == $FORM{'topic'}) { last }
        }

        # print out the beginning of the page

        print "<html><head><title>$topic</title></head><body>\n";
        &sig;                                
        print "<h1>$topic</h1>\n";
        print "<center><table border=\"5\" width=\"500\"><tr><td><table cols=\"2\">\n";
        print "<form method=\"POST\"><input type=\"hidden\" name=\"action\" ";
        print "value=\"vote\">\n<input type=\"hidden\" name=\"topic\" value=\"$num\">\n";

        # print the choices

        open(FILE,"$data_path/ch$num.txt");
        @lines = <FILE>;
        close(FILE);
        $first = 0;
        foreach $line(@lines) {
                ($choice, $x, $num) = split(/\|/, $line);
                print "<tr><td width=\"10\"><input type=\"radio\" name=\"choice\"";
                print " value=\"$num\"";
                if ($first == 0) { print " CHECKED"; $first = 1; }
                print "></td><td width=\"490\"><b><i>$choice</i>";
                print "</b></td></tr>\n";
        }
        if ($others eq "yes\n") {
                print "<tr><td width=\"10\"><input type=\"radio\" name=\"choice\"";
                print " value=\"add_choice\"></td><td width=\"490\"><input type=";
                print "\"text\" name=\"new_choice\"></td></tr>\n";
        }
        print "</table><center><input type=\"submit\" value=\" Vote! \"></center>\n";
        print "</form></td></tr></table>\n";
        &sig;
        exit;
}

sub vote {       
        open (FILE, "$data_path/ip$FORM{'topic'}.txt");
        @ips = <FILE>;
        close(FILE);
        foreach $ip(@ips) {
                chomp($ip);
                if ($ip eq $ENV{'REMOTE_ADDR'}) {
                        print "<html><head><title>Please only vote once</title></head>\n";
                        print "<body><h1>Please only vote once</h1>I'm sorry, but someone\n";
                        print "with the IP address $ENV{'REMOTE_ADDR'} has already voted.\n";
                        print "Please click back.</body></html>\n";
                        exit;
                }
        }
        open (FILE, "$data_path/ch$FORM{'topic'}.txt");
        @choices = <FILE>;
        close(FILE);
        if ($FORM{'choice'} eq "add_choice") {
                unless ($FORM{'new_choice'}) {
                        print "<html><head><title>Missing information</title><head><body>\n";
                        print "You've attempted to add another choice, but you\n";
                        print "didn't fill out what that choice was supposed to be!\n";
                        print "<p>Please click back and try again</body></html>\n";
                        exit;
                }
                chomp($choices[$#choices]);
                ($x,$y,$last) = split(/\|/, $choices[$#choices]);
                $last++;
                open (FILE, ">>$data_path/ch$FORM{'topic'}.txt");
                print FILE "$FORM{'new_choice'}|1|$last\n";
                close(FILE);
                open (FILE, ">>$data_path/ip$FORM{'topic'}.txt");
                print FILE "$ENV{'REMOTE_ADDR'}\n";
                close(FILE);
                &results;
        }
        open (FILE, ">$data_path/ch$FORM{'topic'}.txt");
        foreach $choice(@choices) {
                chomp($choice);
                ($x,$y,$last) = split(/\|/, $choice);
                if ($last == $FORM{'choice'}) { $y++; }
                print FILE "$x|$y|$last\n";
        }
        close(FILE);
        open (FILE, ">>$data_path/ip$FORM{'topic'}.txt");
        print FILE "$ENV{'REMOTE_ADDR'}\n";
        close(FILE);
        &results;
}

sub results {
        foreach $line(@data) {
                ($topic, $num, $others) = split(/\|/, $line);                
                if ($num eq $FORM{'topic'}) { last }
        }
        print "<html><head><title>$topic :: Results</title></head><body>\n";        
        &sig;
        print "<h1>$topic</h1>\n";
        print "<center><table width=\"500\" border=\"5\"><tr><td>\n";
        print "<table cols=\"3\"><tr><td width=\"400\"><center><b>Choice</b></td>\n";
        print "<td width=\"50\"><center><b>Votes</b></center></td><td width=\"50\">\n";
        print "<center><b>%</b></center></td></tr>\n";
        open (FILE, "$data_path/ch$FORM{'topic'}.txt");
        @lines = <FILE>;
        close(FILE);
        $i = 0;
        foreach $line(@lines) {
                ($topic,$votes,$num) = split(/\|/, $line);
                $i = $i + $votes;
        }
        foreach $line(@lines) {
                ($topic,$votes,$num) = split(/\|/, $line);
                if ($i > 0) { $percent = sprintf("%.2f",100 * ($votes / $i)); }
                else { $percent = "NA"; }
                print "<tr><td width=\"400\"><i>$topic</i></td>";
                print "<td width=\"50\"><i>$votes</i></td>";
                print "<td width=\"50\"><i>$percent</i></td></tr>\n";
        }
        print "</table></td></tr></table></center>\n";
        &sig;
        print "</body></html>\n";
        exit;
}

sub delete {
        &checkpassword;
        ($type,$num,$topic) = split(/\|/, $FORM{'which'});
        if ($type eq "c") {
                open (FILE, "$data_path/ch$topic.txt");
                @lines = <FILE>;
                close(FILE);
                open (FILE, ">$data_path/ch$topic.txt");
                foreach $line(@lines) {
                        chomp($line);
                        ($name,$votes,$numc) = split(/\|/, $line);
                        unless ($numc == $num) { print FILE "$line\n"; }
                }
                close(FILE);
        }
        if ($type eq "t") {
                open (FILE, "$data_path/vote.txt");
                @lines = <FILE>;
                close(FILE);
                open (FILE, ">$data_path/vote.txt");
                foreach $line(@lines) {
                        chomp($line);
                        ($topic, $numt, $others) = split(/\|/,$line);
                        unless ($numt == $num) { print FILE "$line\n"; }
                }
                close(FILE);
                unlink("$data_path/ch$num.txt");
                unlink("$data_path/ip$num.txt");
        }
        &admin;
}
